# packages_info_platform_interface

A common platform interface for the [`packages_info`][1] plugin.

This interface allows platform-specific implementations of the `packages_info`
plugin, as well as the plugin itself, to ensure they are supporting the
same interface.

# Usage

To implement a new platform-specific implementation of `packages_info`, extend
[`PackagesInfoPlatform`][2] with an implementation that performs the
platform-specific behavior, and when you register your plugin, set the default
`PackagesInfoLoader` by calling the `PackagesInfoPlatform.loader` setter.

# Note on breaking changes

Strongly prefer non-breaking changes (such as adding a method to the interface)
over breaking changes for this package.

## Features and bugs

Please file feature requests and bugs at the [issue tracker][tracker].

[tracker]: http://example.com/issues/replaceme

[1]: ../packages_info
[2]: lib/packages_info_platform_interface.dart