import 'package:flutter/services.dart';
import 'package:packages_info_platform_interface/option.dart';

import 'package.dart';
import 'packages_info_platform_interface.dart';

const MethodChannel _kChannel = packagesInfoMethodChannel;

/// An implementation of [PackagesInfoPlatform] that uses method channels.
class MethodChannelPackagesInfo extends PackagesInfoPlatform {
  @override
  Future<Iterable<Package>> getInstalledPackages([
    Options options = const Options(),
  ]) async {
    final packages = await _kChannel.invokeListMethod(
          'getInstalledPackages',
          options.toMap,
        ) ??
        [];
    return packages.map((it) => Package.fromMap(it));
  }

  @override
  Future<Package> getPackageInfo(
    String packageIdentifier, [
    Options options = const Options(),
  ]) async {
    final _options = options.copyWith(packageIdentifier: packageIdentifier);
    final map = await _kChannel.invokeMapMethod<String, dynamic>(
      'getPackageInfo',
      _options.toMap,
    );

    return Package.fromMap(map ?? {});
  }
}
