import 'package:packages_info_platform_interface/option.dart';
import 'package:packages_info_platform_interface/package.dart';

import 'packages_info_platform_interface.dart';

/// A stub implementation to satisfy compilation of multi-platform packages that
/// depend on packages_info_platform_interface. This should never actually be created.
///
/// Notably, because packages_info needs to manually register
/// federated dependencies, anything with a transitive dependency on
/// packages_info will also depend on any of those dependencies, not just at
/// the pubspec level but the code level.
class PackagesInfoStub extends PackagesInfoPlatform {
  /// Errors on attempted instantiation of the stub. It exists only to satisfy
  /// compile-time dependencies, and should never actually be created.
  PackagesInfoStub() {
    // ignore: prefer_asserts_in_initializer_lists
    assert(false);
  }

  @override
  Future<Iterable<Package>> getInstalledPackages([
    Options options = const Options(),
  ]) {
    throw UnimplementedError();
  }

  @override
  Future<Package> getPackageInfo(
    String packageIdentifier, [
    Options options = const Options(),
  ]) {
    throw UnimplementedError();
  }
}
